package buw;

import openfl.display.Sprite;
import openfl.events.MouseEvent;

class CheckBox extends Control {
	public var checked(get, set): Bool;
	var hbox : HBox;
	var checkedSprite : Sprite;
	var unCheckedSprite : Sprite;

	function new(listener : CheckBox -> Void, text : String, ?checked : Bool = false) {
		super(cast listener);
		this.checked = checked;
		hbox = new HBox(0);
		var toggle = new Widget();
		toggle.addEventListener(MouseEvent.CLICK, onClick);
		toggle.addChild(checkedSprite);
		toggle.addChild(unCheckedSprite);
		hbox.pack(toggle);
		var label : Label = new Label(text);
		hbox.pack(label);
		addChild(hbox);
	}

	function get_checked() : Bool {
		return checkedSprite.visible;
	}

	function set_checked(checked : Bool): Bool {
		checkedSprite.visible = checked;
		unCheckedSprite.visible = !checked;
		return checkedSprite.visible;
	}

	function onClick(e : MouseEvent) {
		checked = !checked;
		if (listener != null) {
			listener(this);
		}
	}
}
