//import openfl.Lib;
import openfl.display.Sprite;
import buw.*;

typedef Book = {
	var author : String;
	var title : String;
}

class Demo extends Sprite {
	var rootWindow : VBox;
	var text : Input;
	var rdb : RadioBox;

	/*public static function main() {
		Lib.current.stage.addChild(new Main());
	}*/

	public function new () {
		super ();
		rootWindow = new VBox(1, -1);
		
		rootWindow.pack(new Title("Example title: "));
		rootWindow.pack(new TextButton(cbListView, "Load ListView"));
		rootWindow.pack(new TextButton(cbTable, "Load Table"));
		rootWindow.pack(new TextCheckBox(function(cb : CheckBox) { trace(cb.checked); }, "checkbox", true));
		rootWindow.pack(new TextSpinBox(null, "spinbox"));
		
		/*var hb1 = new HBox(1, [new HBoxColumn(0.33), new HBoxColumn(0.33), new HBoxColumn(0.33)]);
		rootWindow.pack(hb1);
		hb1.pack(new TextButton(null, "Inactive 1"));
		hb1.pack(new TextButton(null, "Inactive 2"));
		hb1.pack(new TextButton(null, "Inactive 3"));*/
		
		rootWindow.pack(new Separator());
		var g : Grid = new Grid(1, [new HBoxColumn(0.3), new HBoxColumn(0.7)]);
		g.pack(new Label("Firstname:"));
		g.pack(new Input(20));
		g.pack(new Label("Lastname:"));
		g.pack(new Input(20));
		rootWindow.pack(g);
		
		rootWindow.pack(new Separator());
		var hb2 = new HBox(1, [new HBoxColumn(0.5), new HBoxColumn(0.5)]);
		rootWindow.pack(hb2);
		hb2.pack(new TextButton(function (w : TextButton) { trace(rdb.selected); }, "Button GetRadio", 0.4));
		hb2.pack(new TextButton(function (w : TextButton) { rdb.selected = (rdb.selected + 1) % 2; }, "Button SetRadio", 0.4));
		rdb = new RadioBox(function (w : RadioBox) { trace("selected is", w.selected); }, true);
		rdb.add(new TextRadioButton("val 1", true));
		rdb.add(new TextRadioButton("val 2", false));
		rootWindow.pack(rdb);

		var hb3 = new HBox(1);
		hb3.pack(new Image("assets/openfl.png", 0.15));
		hb3.pack(new Image("assets/haxe.png", 50));
		rootWindow.pack(hb3);

		Screen.display(rootWindow);
	}

	function cbListView(w : TextButton) {
		rootWindow.pack(new Separator());
		rootWindow.pack(new Title("ListView content:"));
		var books : List<Book> = new List();
		books.add({title : "Les misérables", author : "Victor Hugo"});
		books.add({title : "20 000 lieues sous les mers", author : "Jules Verne"});
		var list : ListView<Book> = new ListView(function(o : Book) : Widget { return new Label(o.title + " - " + o.author); },
			function (o : Book) { trace(o.title); });
		list.source = books;
		list.push({title : "Ensemble c'est tout", author : "Anna Gavalda"});
		rootWindow.pack(list);
	}

	function cbTable(w : TextButton) {
		rootWindow.pack(new Separator());
		var books : Array<Book> = new Array();
		books.push({title : "La Horde du contrevent", author : "Alain Damasio"});
		books.push({title : "La fraternité du Panca", author : "Pierre Bordage"});
		var table : Table<Book> = new Table(function (o : Book) { trace(o.title); }, 1, 
			[new TableColumn(0.65, "Title", "title"), new TableColumn(0.35, "Author", "author")]);
		table.source = books;
		table.push({title : "Ravage", author : "Barjavel"});
		rootWindow.pack(table);
	}
}
