import buw.*;

/**
 * example 1: form with reset button
 * using: VBox, HBox, TextButton, Input, Label, RadioBox, TextCheckBox & Separator
 */

class Example1 extends openfl.display.Sprite {
	var first : Input;
	var last : Input;
	var adult : TextCheckBox;
	var gender : RadioBox;

	function new() {
		super();

		//create the vertical box container:
		var form = new VBox(1, -1); //use 100% (1) of the screen width, with alignement set to the left (-1)

		//one can add a separator at the top of the form:
		form.pack(new Separator());

		//create an horizontal (cf false) radio box, with two buttons:
		gender = new RadioBox(false).add(new TextRadioButton("M.")).add(new TextRadioButton("Ms."));
		//the widget is stored in a class field to allow callback functions to access the properties of this object (the selected item)

		//stack the radio box into the vertical container:
		form.pack(gender);

		//create then stack two inputs (with labels):
		first = new Input(20); //by default, inputs use 100% of available width
		last = new Input(20);
		form.pack(new Label("Firstname:"));
		form.pack(first);
		form.pack(new Label("Lastname:"));
		form.pack(last);

		//create and stack a check box:
		adult = new TextCheckBox("I am over 18");
		form.pack(adult);

		form.pack(new Separator());

		//add two buttons in an horizontal box:
		var buttons = new HBox(); //by default, the horizontal box will use 100% of the width of its parent
		buttons.pack(new TextButton(onOkClick, "OK", 0.5)); //will use 50% (0.5) of the horizontal box width
		buttons.pack(new TextButton(onResetClick, "Reset", 0.5));
		form.pack(buttons);

		//display the form (vertical box)
		Screen.display(form);
	}

	//the callbacks function receive the clicked widget as parameter:
	function onOkClick(w : TextButton) {
		var prefix : String;
		if (gender.selected == 0) { //access radio box selected item (integer, [0..n-1])
			prefix = "Mister ";
		} else {
			prefix = "Misses ";
		}
		trace(prefix + first.value + " " + last.value); //access inputs values
		if (adult.checked) { //access check box checked value (boolean)
			trace("Ok, You are over 18.");
		}
	}

	function onResetClick(w : TextButton) {
		first.value = ""; //change (reset) input value
		last.value = "";
		adult.checked = false; //change check box state
		gender.selected = 0; //change radio box selected item
	}
}
