import buw.*;

/**
 * example 3: table view
 * using: Table (TableColumn), Image, HBox & Label
 */

typedef Book = {
	var author : String;
	var title : String;
	var alive : Bool;
}

class Example4 extends openfl.display.Sprite {
	function new() {
		super();
		//in this example, a collection of books is displayed in a table;
		//a table has columns that have a (relative) width, a title and the field name to display or a rendering function for the cell:
		var booksTable : Table<Book> = new Table(
			function (o : Book) { trace(o.title); }, 
			[
				new TableColumn(0.6, "Title", "title"), //for the first colum, the book title is displayed (in a Label)
				new TableColumn(0.4, "Author", renderAuthorColumn) //for the second one, the cell is rendered by a function
			]);
		Screen.display(booksTable);

		var books : Array<Book> = new Array();
		books.push({title : "La Horde du contrevent", author : "Alain Damasio", alive : true});
		books.push({title : "La fraternité du Panca", author : "Pierre Bordage", alive : true});
		books.push({title : "Ravage", author : "René Barjavel", alive : false});
		
		booksTable.source = books;
	}

	function renderAuthorColumn (b : Book) : Widget {
		//the author column is rendered in an horizontal box:
		var hbox = new HBox();
		//containing the authors name:
		hbox.pack(new Label(b.author));
		if (! b.alive) {
			//and an image if dead:
			hbox.pack(new Image("assets/rip.jpg", Widget.controlsFontSize));
		}
		return hbox;
	}
}
